Package com.io7m.waxmill.machines

# Class WXMEvaluatedBootCommands

java.lang.Object
com.io7m.waxmill.machines.WXMEvaluatedBootCommands

All Implemented Interfaces:
  `WXMBootConfigurationType.WXMEvaluatedBootCommandsType`

    public final class WXMEvaluatedBootCommands
    extends java.lang.Object
    implements WXMBootConfigurationType.WXMEvaluatedBootCommandsType

A set of boot commands.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMEvaluatedBootCommands.Builder` | Builds instances of type `WXMEvaluatedBootCommands`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMEvaluatedBootCommands.Builder` | `builder()` | Creates a builder for `WXMEvaluatedBootCommands`.
  `java.util.List<WXMCommandExecution>` | `configurationCommands()` |
  `static WXMEvaluatedBootCommands` | `copyOf​(WXMBootConfigurationType.WXMEvaluatedBootCommandsType instance)` | Creates an immutable copy of a `WXMBootConfigurationType.WXMEvaluatedBootCommandsType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMEvaluatedBootCommands` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `configurationCommands`, `lastExecution`.
  `java.util.Optional<WXMCommandExecution>` | `lastExecution()` | The final execution to bring up the virtual machine.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMEvaluatedBootCommands` with attribute values.
  `WXMEvaluatedBootCommands` | `withConfigurationCommands​(WXMCommandExecution... elements)` | Copy the current immutable object with elements that replace the content of `configurationCommands`.
  `WXMEvaluatedBootCommands` | `withConfigurationCommands​(java.lang.Iterable<? extends WXMCommandExecution> elements)` | Copy the current immutable object with elements that replace the content of `configurationCommands`.
  `WXMEvaluatedBootCommands` | `withLastExecution​(WXMCommandExecution value)` | Copy the current immutable object by setting a present value for the optional `lastExecution` attribute.
  `WXMEvaluatedBootCommands` | `withLastExecution​(java.util.Optional<? extends WXMCommandExecution> optional)` | Copy the current immutable object by setting an optional value for the `lastExecution` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### configurationCommands

    public java.util.List<WXMCommandExecution> configurationCommands()
    Specified by:
      `configurationCommands` in interface `WXMBootConfigurationType.WXMEvaluatedBootCommandsType`
    Returns:
      A list of commands executed in declaration order to configure the virtual machine

  - ### lastExecution

    public java.util.Optional<WXMCommandExecution> lastExecution()
    The final execution to bring up the virtual machine. This is typically executed using the operating system's equivalent of `execve()` and will therefore replace the current process.
    Specified by:
      `lastExecution` in interface `WXMBootConfigurationType.WXMEvaluatedBootCommandsType`
    Returns:
      The final execution used to bring up the virtual machine

  - ### withConfigurationCommands

    public final WXMEvaluatedBootCommands withConfigurationCommands​(WXMCommandExecution... elements)
    Copy the current immutable object with elements that replace the content of `configurationCommands`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withConfigurationCommands

    public final WXMEvaluatedBootCommands withConfigurationCommands​(java.lang.Iterable<? extends WXMCommandExecution> elements)
    Copy the current immutable object with elements that replace the content of `configurationCommands`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of configurationCommands elements to set
    Returns:
      A modified copy of `this` object

  - ### withLastExecution

    public final WXMEvaluatedBootCommands withLastExecution​(WXMCommandExecution value)
    Copy the current immutable object by setting a present value for the optional `lastExecution` attribute.
    Parameters:
      `value` - The value for lastExecution
    Returns:
      A modified copy of `this` object

  - ### withLastExecution

    public final WXMEvaluatedBootCommands withLastExecution​(java.util.Optional<? extends WXMCommandExecution> optional)
    Copy the current immutable object by setting an optional value for the `lastExecution` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - A value for lastExecution
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMEvaluatedBootCommands` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `configurationCommands`, `lastExecution`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMEvaluatedBootCommands` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMEvaluatedBootCommands copyOf​(WXMBootConfigurationType.WXMEvaluatedBootCommandsType instance)
    Creates an immutable copy of a `WXMBootConfigurationType.WXMEvaluatedBootCommandsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMEvaluatedBootCommands instance

  - ### builder

    public static WXMEvaluatedBootCommands.Builder builder()
    Creates a builder for `WXMEvaluatedBootCommands`.

         WXMEvaluatedBootCommands.builder()
            .addConfigurationCommands|addAllConfigurationCommands(WXMCommandExecution) // configurationCommands elements
            .setLastExecution(WXMCommandExecution) // optional lastExecution
            .build();

    Returns:
      A new WXMEvaluatedBootCommands builder